/* Auther: Hilda Chang He 
** Date: 2016 Winter
**
**
** This is a data visualization project. 
** The data is from Seattle Public Library. Thanks for the supply from George.
** The project idea is to see how new books perform during time passed.
** The visualization design is inspired by Karl and the OLAP Cube concept.
** This project visualize every checkout records in SPL based on its checkOut time, checkOut order and loan duration. 
** And data are catagorized as fiction and non-fictions.
**
**/


import controlP5.*;
import peasy.*;
import java.awt.*;
PeasyCam cam;
ControlP5 cp5;

//for testing now, use 2015 --> keep it, dono why but keep it plz
int startYear = 2015;

//parameters
int xrange = 800;
int yrange = 500; // 200 + 100 + 200
int zrange = 800;
int camDepth = 600;
int xMargin = 100;

int numOfSet = 1;

//Load tables: fiction2015, nonfic2015
DataTable fiction2015;
DataTable nonfic2015;
DataTable fiction2014;
DataTable nonfic2014;
DataTable fiction2013;
DataTable nonfic2013;

//view mode
int viewAngle = 0;
boolean switch2013 = false;
boolean switch2014 = false;
boolean switch2015 = true;

//interactive functions
int[][] points;
String name;
int copies;
int checkOutTimes;
String bookDescription;

//color container
int yearIndicator;

CheckBox yearCheckbox;

PFont font;

void setup(){
  //set screen size
  //size(1200, 700, P3D);
  size(900, 600, P3D);
  smooth();
  //get peasy cam ready
  cam = new PeasyCam(this, (xrange - (numOfSet -1) * xrange)/2, (yrange-100)/2, -zrange/2, zrange/1.5 + camDepth * numOfSet * 0.6);
  
  //load data
  fiction2015 = new DataTable("fiction2015.csv", 2015, true);
  println();
  nonfic2015 = new DataTable("nonfiction2015.csv", 2015, false);
  println();
  fiction2014 = new DataTable("fiction2014.csv", 2014, true);
  println();
  nonfic2014 = new DataTable("nonfiction2014.csv", 2014, false);
  println();
  fiction2013 = new DataTable("fiction2013.csv", 2013, true);
  println();
  nonfic2013 = new DataTable("nonfiction2013.csv", 2013, false);
  println("<<<<<<<<<<<<<<<<<<<<<<finish initialization!!!!!!<<<<<<<<<<<<<<<<<<<<<<<<");
  
  //color initiation
  
  //get control panel ready
  cp5 = new ControlP5(this);
  
  controlPanel();
  
  //test findBooksByName()     ;)
  //name = "Her a novel";
  //points = fiction2015.findBooksByName(name);
  //if(points == null){
  //  println("nothing found");
  //}else{
  //  for(int i = 0; i< points.length; i++ ){
  //    println(points[i][0] + "  " + points[i][1] + "  " + points[i][2]);
  //  }
  //}
  
  
  
}

void draw(){
  background(150);
  
  //draw pins of fiction2015
  if(viewAngle == 0){
    if(switch2015){
      drawPin(fiction2015.x, fiction2015.yLength, fiction2015.z, fiction2015.isFiction, fiction2015.publishYear);
      drawPin(nonfic2015.x, nonfic2015.yLength, nonfic2015.z, nonfic2015.isFiction, nonfic2015.publishYear);

    }
    if(switch2014){
      drawPin(fiction2014.x, fiction2014.yLength, fiction2014.z, fiction2014.isFiction, fiction2014.publishYear);
      drawPin(nonfic2014.x, nonfic2014.yLength, nonfic2014.z, nonfic2014.isFiction, nonfic2014.publishYear);

    }
    if(switch2013){
      drawPin(fiction2013.x, fiction2013.yLength, fiction2013.z, fiction2013.isFiction, fiction2013.publishYear);
      drawPin(nonfic2013.x, nonfic2013.yLength, nonfic2013.z, nonfic2013.isFiction, nonfic2013.publishYear);
    }
    
  }
  if(viewAngle == 1){
      if(switch2015){
        drawPin(fiction2015.x, fiction2015.yLength, fiction2015.z, fiction2015.isFiction, fiction2015.publishYear);
      }
      if(switch2014){
        drawPin(fiction2014.x, fiction2014.yLength, fiction2014.z, fiction2014.isFiction, fiction2014.publishYear);
      }
      if(switch2013){
        drawPin(fiction2013.x, fiction2013.yLength, fiction2013.z, fiction2013.isFiction, fiction2013.publishYear);
      }
      pushMatrix();
      translate(2 * xrange + 100, yrange, 0);
      rotate(PI);
      if(switch2015){
        drawPin(nonfic2015.x, nonfic2015.yLength, nonfic2015.z, nonfic2015.isFiction, nonfic2015.publishYear);
      }
      if(switch2014){
        drawPin(nonfic2014.x, nonfic2014.yLength, nonfic2014.z, nonfic2014.isFiction, nonfic2014.publishYear);
      }
      if(switch2013){
        drawPin(nonfic2013.x, nonfic2013.yLength, nonfic2013.z, nonfic2013.isFiction, nonfic2013.publishYear);
      }
      popMatrix();
  }
  if(viewAngle == 2){
      if(switch2015){
        drawPin(fiction2015.x, fiction2015.yLength, fiction2015.z, fiction2015.isFiction, fiction2015.publishYear);
      }
      if(switch2014){
        drawPin(fiction2014.x, fiction2014.yLength, fiction2014.z, fiction2014.isFiction, fiction2014.publishYear);
      }
      if(switch2013){
        drawPin(fiction2013.x, fiction2013.yLength, fiction2013.z, fiction2013.isFiction, fiction2013.publishYear);
      }
      pushMatrix();
      translate(2 * xrange + 100, yrange, 0);
      rotate(PI);
      if(switch2015){
        drawPin(nonfic2015.x, nonfic2015.yLength, nonfic2015.z, nonfic2015.isFiction, nonfic2015.publishYear);
      }
      if(switch2014){
        drawPin(nonfic2014.x, nonfic2014.yLength, nonfic2014.z, nonfic2014.isFiction, nonfic2014.publishYear);
      }
      if(switch2013){
        drawPin(nonfic2013.x, nonfic2013.yLength, nonfic2013.z, nonfic2013.isFiction, nonfic2013.publishYear);
      }
      popMatrix();
  }


  gui();
  
  
  //test drawCurve
  drawCurve(points);
  

  //for test
  //fill(0, 20); 
  //box(200);
  
  //strokeWeight(5);
  //stroke(0);
  //drawPin(new PVector(0,100,0));
  
}