//color setting
//String colorPath = "color2.jpeg";
//PImage colorSkin;

public void drawPin(ArrayList<Integer> x, ArrayList<Integer> yLength, ArrayList<Integer> z,
                    boolean isFiction, int publishYear){
    if(isFiction){// fiction: up
      pushMatrix();
      //draw lines 
      strokeWeight(1);
      stroke(255);
      beginShape(LINES);
      for(int i = 0; i < x.size(); i++){
          vertex(x.get(i), 0, z.get(i));
          vertex(x.get(i), yLength.get(i), z.get(i));
      }
      endShape();
      //draw ending point
      switch(publishYear){
        case 2015:
          stroke(40, 180, 250, 200);
          break;
        case 2014:
          stroke(250, 180, 10, 200);
          break;
        case 2013:
          stroke(250, 100, 120, 200);
          break;
      }
      strokeWeight(4);      
      beginShape(POINTS);
      for(int i = 0; i < x.size(); i++){
          vertex(x.get(i), yLength.get(i), z.get(i));
      }
      endShape();
      popMatrix();
    }else{//nonFiction: down
      pushMatrix();
      //draw lines 
      strokeWeight(1);
      stroke(255);
      beginShape(LINES);
      for(int i = 0; i < x.size(); i++){
          vertex(x.get(i), yrange, z.get(i));
          vertex(x.get(i), yrange - yLength.get(i), z.get(i));
      }
      endShape();
      //draw ending point
      switch(publishYear){
        case 2015:
          stroke(40, 180, 250, 200);
          break;
        case 2014:
          stroke(250, 180, 10, 200);
          break;
        case 2013:
          stroke(250, 100, 120, 200);
          break;
      }
      strokeWeight(4);      
      beginShape(POINTS);
      for(int i = 0; i < x.size(); i++){
          vertex(x.get(i), yrange - yLength.get(i), z.get(i));
      }
      endShape();
      popMatrix();
    }
}


public int dateToday(Date date){
    int days = (date.year - startYear) * 365 + (date.month - 1) * 30 + date.day;
    return days;
}


public void drawCurve(int[][] curves){
    //color c = colorSkin.get(colorSkin.width/2, 1);
    //HSBcolor = Color.RGBtoHSB(40, 180, 250, HSBcolor);
    
    if(curves != null){
        pushMatrix();
        for(int i = 0 ; i < curves.length-1; i++){
          if(curves[i][0] <= curves[i+1][0]){
            if(yearIndicator == 2013){ stroke(map(i, 0, curves.length-1, 230, 150),
                                              map(i, 0, curves.length-1, 84, 0), 
                                              map(i, 0, curves.length-1, 115, 80));//250, 100, 120
            }else if(yearIndicator == 2014){ stroke(map(i, 0, curves.length-1, 200, 70),
                                                    map(i, 0, curves.length-1, 130, 70), 10);//250, 180,10
            }else if(yearIndicator == 2015){ stroke(40, map(i, 0, curves.length-1, 150, 0), 250);}
            strokeWeight(1);
            noFill();
            curve(curves[i][0], 20 * curves[i][1], curves[i][2],     curves[i][0], 0, curves[i][2],
                  curves[i+1][0], 0, curves[i+1][2],    curves[i+1][0], 20 * curves[i+1][1], curves[i+1][2]);
          }else{
          }
          
        }
        popMatrix();
    }
  
}





//unusable
public int countTimesOnDate(ArrayList<Record> records, Date date){ 
    int count = 0;
    for(int i = 0; i < records.size(); i++){
      Record cRecord = records.get(i);
      if(cRecord.checkOut.year == date.year 
         && cRecord.checkOut.month == date.month
         && cRecord.checkOut.day == date.day){
          count++; 
      }else if(cRecord.checkOut.month == date.month && cRecord.checkOut.day > date.day){
        break;
      }
      i++;
    }
    return count;
}

public float timeParser(String rawTime){
  String[] times = split(rawTime, ':');
  float parsedTime = float(times[0])*60 + float(times[1]);
  return parsedTime;
}